include "Cabin.gs"

class testcarinterior isclass Cabin
{
  bool m_bIsForwardPressed, m_bIsBackwardPressed, m_bIsLeftPressed, m_bIsRightPressed;
  
  
  thread void ThreadedMovement(void)
  {
    MapObject vehicle = cast<MapObject>(GetParentObject());
    float speed;
    float turnRate;
    
    while (true)
    {
      //
      if (m_bIsForwardPressed == m_bIsBackwardPressed)
        speed = 0;
      else if (m_bIsForwardPressed)
        speed = 1.0;
      else if (m_bIsBackwardPressed)
        speed = -1.0;
        
      if (m_bIsLeftPressed == m_bIsRightPressed)
        turnRate = 0;
      else if (m_bIsLeftPressed)
        turnRate = 0.1;
      else if (m_bIsRightPressed)
        turnRate = -0.1;
      
      //
      vehicle.AdjustMapObjectPosition(0, - speed, 0);
      
      Orientation orientation = vehicle.GetMapObjectOrientation();
      orientation.rz = orientation.rz + turnRate;
      vehicle.SetMapObjectOrientation(orientation);
      
      //
      Sleep(0.01);
    }
  }
  
  public void Init(Asset asset)
  {
    inherited(asset);
    
    AddHandler(me, "ControlSet", "vehicle-forward", "HandleKeyForward");
    AddHandler(me, "ControlSet", "vehicle-forward-up", "HandleKeyForwardUp");
    AddHandler(me, "ControlSet", "vehicle-backward", "HandleKeyBackward");
    AddHandler(me, "ControlSet", "vehicle-backward-up", "HandleKeyBackwardUp");
    AddHandler(me, "ControlSet", "vehicle-left", "HandleKeyLeft");
    AddHandler(me, "ControlSet", "vehicle-left-up", "HandleKeyLeftUp");
    AddHandler(me, "ControlSet", "vehicle-right", "HandleKeyRight");
    AddHandler(me, "ControlSet", "vehicle-right-up", "HandleKeyRightUp");
    
    ThreadedMovement();
  }
  
  public void HandleKeyForward(Message msg)
  {
    m_bIsForwardPressed = true;
  }
  
  public void HandleKeyForwardUp(Message msg)
  {
    m_bIsForwardPressed = false;
  }
  
  public void HandleKeyBackward(Message msg)
  {
    m_bIsBackwardPressed = true;
  }
  
  public void HandleKeyBackwardUp(Message msg)
  {
    m_bIsBackwardPressed = false;
  }
  
  public void HandleKeyLeft(Message msg)
  {
    m_bIsLeftPressed = true;
  }
  
  public void HandleKeyLeftUp(Message msg)
  {
    m_bIsLeftPressed = false;
  }
  
  public void HandleKeyRight(Message msg)
  {
    m_bIsRightPressed = true;
  }
  
  public void HandleKeyRightUp(Message msg)
  {
    m_bIsRightPressed = false;
  }
};
